import os
import json
import time
from pyecharts import Bar
import serial
import ctypes


def writeDict2File(fileName,dict_data):
    js = json.dumps(dict_data)
    #file = open(fileName, 'w')
    file = open(fileName, 'a', encoding='utf-8')
    file.write('\n'+js)
    file.close()
    #print('Write OK')

def showWearingMasks(FilePath):
    fileName = os.path.join(os.getcwd(),FilePath)
    attr = ["2021-7-13"]
    dictList = []
    i = 0
    v1=[0]
    v2=[0]
    with open(fileName, 'r', encoding='utf-8') as f:
        for line in f.readlines():
            #print(line.strip())
            js = json.loads(line.strip())
            dictList.append(js)
    for oneData in dictList:
        if oneData["date"] == attr[i] :
            if oneData["type"] == "Mask":
                v1[i] += 1
            else:
                v2[i] += 1
        else:
            attr.append(oneData["date"])
            if oneData["type"] == "Mask":
                v1.append(1)
                v2.append(0)
            else:
                v1.append(0)
                v2.append(1) 
            i += 1 
    bar=Bar("宿舍口罩佩戴情况")
    bar.add("戴口罩",attr,v1,is_stack=True)
    bar.add("不戴口罩",attr,v2,is_stack=True)
    bar.render()

if __name__ == '__main__':
    player = ctypes.windll.kernel32
    ser = serial.Serial('com16',115200) #打开串口
    time.sleep(5)
    send_data = '{"function": "Object Recognition","args":["v2model_0b5431c82a9b1d32"]}\r\n'
    if (ser.isOpen()):
        ser.write(send_data.encode('utf-8'))  #utf-8 编码发送
        print("发送成功",send_data)
    else:
        print("发送失败")
    time.sleep(5)
    data = '' #用于存储数据
    data = data.encode('utf-8')#串口使用的是字节，要进行转码，否则串口不识别
    ser.flushInput()#清除缓冲区
    while True:
      time.sleep(5)#5秒识别一次
      showWearingMasks('daily_mask_wearing_data.txt')
      data = ser.readline()#获取一行的数据长度
      ser.flushInput()#清除缓冲区
      data_str = str(data,'utf-8')#bytes转换成字符串
  
      try:#处理解析异常的问题
        dict_data = json.loads(data_str)#字符串转换成字典
        #print(dict_data)
              #记录数据
        if dict_data["num"] == 2 and dict_data["running"] == "Object Recognition" :
            obj0 = dict_data["obj"][0]
            obj1 = dict_data["obj"][1]

            if obj0["type"] == "person" :
                res = obj1
            else:
                res = obj0
        
            if res["prob"] > 0.8:#概率值为80%以上才认为识别到
                dict_target = {"date": "", "type": ""}
                date = time.strftime("%Y-%m-%d", time.localtime())
                dict_target["date"] = date
                
                if res["type"] == "NoMask":
                    #print(date)
                    print("NoMask")
                    dict_target["type"] = "NoMask"
                    writeDict2File('daily_mask_wearing_data.txt',dict_target)
                    #player.Beep(800,500)
                elif res["type"] == "Mask":
                    print("Mask")
                    dict_target["type"] = "NoMask"
                    writeDict2File('daily_mask_wearing_data.txt',dict_target)
      except json.decoder.JSONDecodeError:
        print("数据异常！")



